﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Proiect_Licenta.Data;

namespace Proiect_Licenta.Migrations
{
    [DbContext(typeof(DataContext))]
    partial class DataContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.10")
                .HasAnnotation("Relational:MaxIdentifierLength", 64);

            modelBuilder.Entity("Proiect_Licenta.Entities.Admin", b =>
                {
                    b.Property<int>("AdminId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<int>("UserId")
                        .HasColumnType("int");

                    b.HasKey("AdminId");

                    b.HasIndex("UserId")
                        .IsUnique();

                    b.ToTable("Admins");
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.Doctor", b =>
                {
                    b.Property<int>("DoctorId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<int>("UserId")
                        .HasColumnType("int");

                    b.HasKey("DoctorId");

                    b.HasIndex("UserId")
                        .IsUnique();

                    b.ToTable("Doctors");
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.LifestyleRecommendation", b =>
                {
                    b.Property<int>("LifestyleRecommendationId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("Diet")
                        .HasColumnType("text");

                    b.Property<DateTime>("LastUpdated")
                        .HasColumnType("datetime");

                    b.Property<int>("PatientId")
                        .HasColumnType("int");

                    b.Property<string>("PhysicalActivities")
                        .HasColumnType("text");

                    b.HasKey("LifestyleRecommendationId");

                    b.HasIndex("PatientId");

                    b.ToTable("LifestyleRecommendations");
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.MLAlgorithms", b =>
                {
                    b.Property<int>("MLAlgorithmId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<float>("Accuracy")
                        .HasColumnType("float");

                    b.Property<float>("F1Score")
                        .HasColumnType("float");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("Parameters")
                        .HasColumnType("text");

                    b.Property<float>("Precision")
                        .HasColumnType("float");

                    b.Property<float>("ROC_AUC_Score")
                        .HasColumnType("float");

                    b.Property<float>("Recall")
                        .HasColumnType("float");

                    b.HasKey("MLAlgorithmId");

                    b.ToTable("MLAlgorithms");
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.MedicalData", b =>
                {
                    b.Property<int>("MedicalDataId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<int>("Age")
                        .HasColumnType("int");

                    b.Property<int>("ChestPain")
                        .HasColumnType("int");

                    b.Property<int>("Cholesterol")
                        .HasColumnType("int");

                    b.Property<bool>("ExerciseAngina")
                        .HasColumnType("tinyint(1)");

                    b.Property<int>("Fbs")
                        .HasColumnType("int");

                    b.Property<int>("NrOfBloodVessels")
                        .HasColumnType("int");

                    b.Property<int>("PatientId")
                        .HasColumnType("int");

                    b.Property<int>("Prediction")
                        .HasColumnType("int");

                    b.Property<int>("RestBp")
                        .HasColumnType("int");

                    b.Property<int>("RestEcg")
                        .HasColumnType("int");

                    b.Property<bool>("Sex")
                        .HasColumnType("tinyint(1)");

                    b.Property<int>("Slope")
                        .HasColumnType("int");

                    b.Property<float>("StDepression")
                        .HasColumnType("float");

                    b.Property<int>("Thalach")
                        .HasColumnType("int");

                    b.Property<int>("Thalassemia")
                        .HasColumnType("int");

                    b.HasKey("MedicalDataId");

                    b.HasIndex("PatientId")
                        .IsUnique();

                    b.ToTable("MedicalDatas");
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.MedicationPlan", b =>
                {
                    b.Property<int>("PlanId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<DateTime>("EndDate")
                        .HasColumnType("datetime");

                    b.Property<DateTime>("LastUpdated")
                        .HasColumnType("datetime");

                    b.Property<int>("PatientId")
                        .HasColumnType("int");

                    b.Property<DateTime>("StartDate")
                        .HasColumnType("datetime");

                    b.HasKey("PlanId");

                    b.HasIndex("PatientId");

                    b.ToTable("MedicationPlans");
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.Message", b =>
                {
                    b.Property<int>("MessageId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("Description")
                        .HasColumnType("text");

                    b.Property<string>("Sender")
                        .HasColumnType("text");

                    b.Property<DateTime>("SentDate")
                        .HasColumnType("datetime");

                    b.Property<string>("Subject")
                        .HasColumnType("text");

                    b.Property<int?>("UserId")
                        .HasColumnType("int");

                    b.Property<string>("Username")
                        .HasColumnType("text");

                    b.HasKey("MessageId");

                    b.HasIndex("UserId");

                    b.ToTable("Messages");
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.Patient", b =>
                {
                    b.Property<int>("PatientId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<int>("DoctorId")
                        .HasColumnType("int");

                    b.Property<int>("UserId")
                        .HasColumnType("int");

                    b.HasKey("PatientId");

                    b.HasIndex("DoctorId");

                    b.HasIndex("UserId")
                        .IsUnique();

                    b.ToTable("Patients");
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.User", b =>
                {
                    b.Property<int>("UserId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<DateTime>("BirthDate")
                        .HasColumnType("datetime");

                    b.Property<string>("FirstName")
                        .IsRequired()
                        .HasColumnType("varchar(20)")
                        .HasMaxLength(20);

                    b.Property<string>("Gender")
                        .IsRequired()
                        .HasColumnType("varchar(10)")
                        .HasMaxLength(10);

                    b.Property<string>("LastName")
                        .IsRequired()
                        .HasColumnType("varchar(20)")
                        .HasMaxLength(20);

                    b.Property<string>("Password")
                        .IsRequired()
                        .HasColumnType("varchar(20)")
                        .HasMaxLength(20);

                    b.Property<string>("Role")
                        .IsRequired()
                        .HasColumnType("varchar(15)")
                        .HasMaxLength(15);

                    b.Property<string>("Username")
                        .IsRequired()
                        .HasColumnType("varchar(20)")
                        .HasMaxLength(20);

                    b.HasKey("UserId");

                    b.HasIndex("Username")
                        .IsUnique();

                    b.ToTable("Users");
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.Admin", b =>
                {
                    b.HasOne("Proiect_Licenta.Entities.User", "User")
                        .WithOne("Admin")
                        .HasForeignKey("Proiect_Licenta.Entities.Admin", "UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.Doctor", b =>
                {
                    b.HasOne("Proiect_Licenta.Entities.User", "User")
                        .WithOne("Doctor")
                        .HasForeignKey("Proiect_Licenta.Entities.Doctor", "UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.LifestyleRecommendation", b =>
                {
                    b.HasOne("Proiect_Licenta.Entities.Patient", "Patient")
                        .WithMany("LifestyleReccomendations")
                        .HasForeignKey("PatientId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.MedicalData", b =>
                {
                    b.HasOne("Proiect_Licenta.Entities.Patient", "Patient")
                        .WithOne("MedicalData")
                        .HasForeignKey("Proiect_Licenta.Entities.MedicalData", "PatientId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.MedicationPlan", b =>
                {
                    b.HasOne("Proiect_Licenta.Entities.Patient", "Patient")
                        .WithMany("MedicationPlans")
                        .HasForeignKey("PatientId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.Message", b =>
                {
                    b.HasOne("Proiect_Licenta.Entities.User", "User")
                        .WithMany("Messages")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Proiect_Licenta.Entities.Patient", b =>
                {
                    b.HasOne("Proiect_Licenta.Entities.Doctor", "Doctor")
                        .WithMany("Patients")
                        .HasForeignKey("DoctorId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Proiect_Licenta.Entities.User", "User")
                        .WithOne("Patient")
                        .HasForeignKey("Proiect_Licenta.Entities.Patient", "UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
